Index: codes/icosagcm/trunk/param_sets/dcmip2016/cyclone/const.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2016/cyclone/const.def	(revision 390)
+++ codes/icosagcm/trunk/param_sets/dcmip2016/cyclone/const.def	(revision 390)
@@ -0,0 +1,33 @@
+
+#---------------- Planet ----------------
+
+# Planetary radius : real (default=6371220)
+radius = 6.37122e6
+
+# Gravity : real (default=9.80616)
+g = 9.80616
+
+# kappa=Rd/cpp : real (default=0.2857143)
+kappa = 0.2857143
+
+# Heat capacity at constant pressure : real (default=1004.70885)
+cpp = 1004.5
+
+# Reference pressure : real (default=101325)
+preff = 1e5
+
+# Planetary rotation rate : real (default=7.292E-5)
+omega = 7.292e-5
+
+
+#---------------- Constants ----------------
+
+# Reference temperature T0 for DCMIP test cases : real (default=300)
+ncar_T0 = 300
+
+# Reference pressure p0 for DCMIP test cases, used by disvert if disver=ncar : real (default=1e5)
+ncar_p0 = 1e5
+
+# Exponent for B(eta), used by disvert if disvert=ncar : integer (default=1)
+ncar_disvert_c = 1
+
Index: codes/icosagcm/trunk/param_sets/dcmip2016/cyclone/job_ada
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2016/cyclone/job_ada	(revision 390)
+++ codes/icosagcm/trunk/param_sets/dcmip2016/cyclone/job_ada	(revision 390)
@@ -0,0 +1,23 @@
+# @ job_type = parallel
+# @ total_tasks = 160
+# Temps CPU max. d'un processus hhh:mm:ss (1h30mn ici)
+# @ wall_clock_limit=1800
+## @ as_limit = 20.0gb
+# Nom du travail LoadLeveler
+# @ job_name = dynamico
+# Fichier de sortie standard du travail
+# @ output   = $(job_name).$(jobid)
+# Fichier de sortie d'erreur du travail
+# @ error    = $(job_name).$(jobid)
+## @ class = debug
+# @ queue
+
+cd $LOADL_STEP_INITDIR
+
+export FOR_DEBUGGER_IS_PRESENT=true
+
+export DISPLAY=ada337:57.0
+
+#xterm -sb -e 'module load tv; tv ../../../bin/icosa_gcm.exe'
+
+poe ../../../bin/icosa_gcm.exe
Index: codes/icosagcm/trunk/param_sets/dcmip2016/cyclone/run.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2016/cyclone/run.def	(revision 390)
+++ codes/icosagcm/trunk/param_sets/dcmip2016/cyclone/run.def	(revision 390)
@@ -0,0 +1,74 @@
+INCLUDEDEF = const.def
+
+#---------------- Mesh ----------------
+
+# Number of subdivisions on a main triangle : integer (default=40)
+nbp = 160
+
+# Number of vertical layers : integer (default=19)
+llm = 30
+
+# Vertical grid : [std|ncar|ncarl30] (default=std)
+disvert = ncarl30
+
+# Mesh optimisation : number of iterations : integer (default=0)
+optim_it = 100
+
+# Sub splitting of main rhombus : integer (default=1)
+nsplit_i = 4
+nsplit_j = 4
+
+
+#---------------- Numerics ----------------
+
+# Time step in s : real (default=480)
+dt = 120
+
+#time_scheme=runge_kutta
+
+
+# Dissipation time for grad(div) : real (default=5000)
+tau_graddiv = 4000
+
+# Exponent of grad(div) disspation : integer (default=1)
+nitergdiv = 2
+
+# Dissipation time for curl(curl) : real (default=5000)
+tau_gradrot = 4000
+
+# Exponent of curl(curl) disspation : integer (default=1)
+nitergrot = 2
+
+# Dissipation time for div(grad) : real (default=5000)
+tau_divgrad = 4000
+
+# Exponent of div(grad) disspation : integer (default=1)
+niterdivgrad = 2
+
+
+#---------------- Time ----------------
+
+# Run length in s : real (default=??)
+run_length = 864000
+
+# Interval in s between two outputs : integer (default=??)
+write_period = 21600
+
+
+#---------------- Physical parameters ----------------
+
+# Number of tracers : integer (default=1)
+nqtot = 5
+
+itau_adv=1
+
+
+# Initial state : 
+#   [jablonowsky06|academic|dcmip[1-4]|heldsz|dcmip2_schaer_noshear] (default=jablonowsky06)
+etat0 = dcmip2016_cyclone
+
+
+itau_physics=1
+physics=dcmip2016
+physics_dcmip2016=cyclone
+
Index: codes/icosagcm/trunk/param_sets/dcmip2016/supercell/const.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2016/supercell/const.def	(revision 390)
+++ codes/icosagcm/trunk/param_sets/dcmip2016/supercell/const.def	(revision 390)
@@ -0,0 +1,33 @@
+
+#---------------- Planet ----------------
+
+# Planetary radius : real (default=6371220)
+radius = 6.37122e6
+
+# Gravity : real (default=9.80616)
+g = 9.80616
+
+# kappa=Rd/cpp : real (default=0.2857143)
+kappa = 0.2857143
+
+# Heat capacity at constant pressure : real (default=1004.70885)
+cpp = 1004.5
+
+# Reference pressure : real (default=101325)
+preff = 1e5
+
+# Planetary rotation rate : real (default=7.292E-5)
+omega = 7.292e-5
+
+
+#---------------- Constants ----------------
+
+# Reference temperature T0 for DCMIP test cases : real (default=300)
+ncar_T0 = 300
+
+# Reference pressure p0 for DCMIP test cases, used by disvert if disver=ncar : real (default=1e5)
+ncar_p0 = 1e5
+
+# Exponent for B(eta), used by disvert if disvert=ncar : integer (default=1)
+ncar_disvert_c = 1
+
Index: codes/icosagcm/trunk/param_sets/dcmip2016/supercell/job_ada
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2016/supercell/job_ada	(revision 390)
+++ codes/icosagcm/trunk/param_sets/dcmip2016/supercell/job_ada	(revision 390)
@@ -0,0 +1,23 @@
+# @ job_type = parallel
+# @ total_tasks = 160
+# Temps CPU max. d'un processus hhh:mm:ss (1h30mn ici)
+# @ wall_clock_limit=1800
+## @ as_limit = 20.0gb
+# Nom du travail LoadLeveler
+# @ job_name = dynamico
+# Fichier de sortie standard du travail
+# @ output   = $(job_name).$(jobid)
+# Fichier de sortie d'erreur du travail
+# @ error    = $(job_name).$(jobid)
+## @ class = debug
+# @ queue
+
+cd $LOADL_STEP_INITDIR
+
+export FOR_DEBUGGER_IS_PRESENT=true
+
+export DISPLAY=ada337:57.0
+
+xterm -sb -e 'module load tv; tv ../../../bin/icosa_gcm.exe'
+
+#poe ../../../bin/icosa_gcm.exe
Index: codes/icosagcm/trunk/param_sets/dcmip2016/supercell/run.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2016/supercell/run.def	(revision 390)
+++ codes/icosagcm/trunk/param_sets/dcmip2016/supercell/run.def	(revision 390)
@@ -0,0 +1,71 @@
+INCLUDEDEF = const.def
+scale_factor = 120 
+#---------------- Mesh ----------------
+
+# Number of subdivisions on a main triangle : integer (default=40)
+nbp = 160
+
+# Number of vertical layers : integer (default=19)
+llm = 30
+
+# Vertical grid : [std|ncar|ncarl30] (default=std)
+disvert = ncarl30
+
+# Mesh optimisation : number of iterations : integer (default=0)
+optim_it = 100
+
+# Sub splitting of main rhombus : integer (default=1)
+nsplit_i = 4
+nsplit_j = 4
+
+
+#---------------- Numerics ----------------
+
+# Time step in s : real (default=480)
+dt = 120
+
+# Dissipation time for grad(div) : real (default=5000)
+tau_graddiv = 4000
+
+# Exponent of grad(div) disspation : integer (default=1)
+nitergdiv = 2
+
+# Dissipation time for curl(curl) : real (default=5000)
+tau_gradrot = 4000
+
+# Exponent of curl(curl) disspation : integer (default=1)
+nitergrot = 2
+
+# Dissipation time for div(grad) : real (default=5000)
+tau_divgrad = 4000
+
+# Exponent of div(grad) disspation : integer (default=1)
+niterdivgrad = 2
+
+
+#---------------- Time ----------------
+
+# Run length in s : real (default=??)
+run_length = 864000
+
+# Interval in s between two outputs : integer (default=??)
+write_period = 120
+
+
+#---------------- Physical parameters ----------------
+
+# Number of tracers : integer (default=1)
+nqtot = 5
+
+itau_adv=1
+
+
+# Initial state : 
+#   [jablonowsky06|academic|dcmip[1-4]|heldsz|dcmip2_schaer_noshear] (default=jablonowsky06)
+etat0 = dcmip2016_supercell
+
+
+itau_physics=1
+physics=dcmip2016
+physics_dcmip2016=supercell
+