Index: codes/icosagcm/trunk/param_sets/dcmip2016/baroclinic_wave/icosa.xml
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2016/baroclinic_wave/icosa.xml	(revision 400)
+++ codes/icosagcm/trunk/param_sets/dcmip2016/baroclinic_wave/icosa.xml	(revision 400)
@@ -0,0 +1,248 @@
+ <context id="icosagcm" >
+   <calendar type="d360" start_date="2000-01-01 00:00:00" time_origin="2000-01-01 00:00:00"/>
+    
+
+   <field_definition level="1" enabled=".TRUE." operation="instant">
+     
+     <field_group id="standard_output" > 
+        
+        <field id="timestep" grid_ref="scalar" unit="s"/>
+        <field id="preff" grid_ref="scalar"    unit="Pa"/>
+        <field id="ap" axis_ref="levp1"   long_name="hybrid A coefficient at layer interface" />
+        <field id="bp" axis_ref="levp1"  long_name="hybrid B coefficient at layer interface" />
+        <field id="mid_ap" axis_ref="lev"   long_name="hybrid A coefficient at midpoints" />
+        <field id="mid_bp" axis_ref="lev"  long_name="hybrid B coefficient at midpoints" />
+       
+        <field_group domain_ref="i">
+           <field id="ps" />
+           <field id="dps"  />
+           <field id="Ai" />
+           <field id="phis" />
+           <field id="precl" />
+       
+           <field_group axis_ref="lev"> 
+              <field id="mass" />
+              <field id="p" />
+              <field id="dmass"/>
+              <field id="theta" />
+              <field id="pk"/>
+              <field id="ulon"/>
+              <field id="ulat"/>
+              <field id="uz"/>
+              <field id="omega"/>
+              <field id="temp"/>
+         
+              <field id="q1"/>
+              <field id="q2"/>
+              <field id="q3"/>
+              <field id="q4"/>
+	      <field id="q5"/>
+          </field_group>
+          <field id="u850" />
+          <field id="v850" />
+          <field id="w850" />
+          <field id="t850" />
+          <field id="omega850"/>                  
+          <field id="u500" />
+          <field id="v500" />
+          <field id="w500" />
+          <field id="t500" />
+          <field id="omega500"/>                  
+          <field id="SST"/>
+                 
+          <field id="ulon_850_500" field_ref="p" axis_ref="lev_pressure" />
+       
+        <field_group axis_ref="levp1"> 
+            <field id="geopot"/>
+        </field_group>
+     </field_group> 
+     
+
+     <field_group domain_ref="v" axis_ref="lev">
+       <field id="vort" />
+       <field id="pv" />
+     </field_group>
+  
+  </field_group>
+
+
+ 
+     <field_group id="read_fields" enabled="false" >
+
+       <field id="relief" field_ref="relief_reg" domain_ref="from_relief" read_access="true"  />
+
+       <field_group domain_ref="from_ecdyn" read_access="true" >
+<!--- conflict       
+         <field id="ps" field_ref="ps_reg" />
+         <field id="z"  field_ref="z_reg"  />
+         <field id="ts" field_ref="ts_reg" />
+       
+         <field_group axis_ref="lev_ecdyn" >
+           <field id="u" field_ref="u_reg"  />
+           <field id="v" field_ref="v_reg"   />
+           <field id="temp" field_ref="temp_reg" />
+           <field id="q"    field_ref="q_reg"    />
+         </field_group>
+ --> 
+       </field_group>
+      
+    </field_group>
+     
+   </field_definition>
+    
+ 
+   <file_definition type="one_file" par_access="collective" output_freq="2h" sync_freq="2h" output_level="10" >
+
+     <file id="output" name="output" enabled=".FALSE."> 
+       <field_group group_ref="standard_output"/>
+     </file>
+
+     <file id="dcmip2016_output" name="output" enabled=".TRUE."> 
+ 
+       <field field_ref="timestep" name="mdt" operation="once" />
+       <field field_ref="preff" name="P0" long_name="reference pressure" operation="once" />
+       <field field_ref="ap" name="hyai"  operation="once" />
+       <field field_ref="bp" name="hybi"  operation="once" />
+       <field field_ref="mid_ap" name="hyam"  operation="once" />
+       <field field_ref="mid_bp" name="hybm"  operation="once" />
+
+       <field_group domain_ref="regular">
+         <field field_ref="ps" name="PS"       standard_name="surface_pressure" long_name="Surface pressure"         unit="Pa" />
+         <field field_ref="phis" operation="once" name="PHIS"   standard_name="surface_geopotential" long_name="Surface geopotential" unit="m2/m2"/>
+         <field field_ref="ulon" name="U"      standard_name="eastward_wind" long_name="Zonal wind"                  unit="m/s"/>
+         <field field_ref="ulat" name="V"      standard_name="northward_wind" long_name="Meridional wind"            unit="m/s"/>
+         <field field_ref="uz" name="W"        standard_name="upward_air_velocity" long_name="Vertical velocity"     unit="m/s"/>
+         <field field_ref="omega" name="OMEGA"        standard_name="lagrangian_tendency_of_air_pressure" long_name="Vertical pressure velocity"     unit="Pa/s"/>
+         <field field_ref="p"  name="P"        standard_name="air_pressure" long_name="Pressure"     unit="Pa"/>
+         <field field_ref="temp"  name="T"        standard_name="air_temperature" long_name="Temperature"     unit="K"/>
+         <field field_ref="q1"  name="Q"        standard_name="specific_humidity"  long_name="Specific humidity"          unit="kg/kg"/>
+         <field field_ref="q2"  name="Qc"                                          long_name="Cloud water mixing ration"  unit="kg/kg"/>
+         <field field_ref="q3"  name="Qr"                                          long_name="Rain water mixing ration"  unit="kg/kg"/>
+         <field field_ref="precl"  name="PRECL"     standard_name="rainfall_rate"  long_name="Large Scale precipitation rate"  unit="m/s"/>
+         <field field_ref="q4"  name="Q1"      long_name="Single chlorine mixing ratio"  unit="kg/kg"/> 
+         <field field_ref="q5"  name="Q2"      long_name="Chlorine gas mixing ratio"  unit="kg/kg"/> 
+         <field field_ref="u850" name="U850"       long_name="Zonal wind at 850 hPa"      unit="m/s"/>
+         <field field_ref="v850" name="V850"       long_name="Meridional wind at 850 hPa"   unit="m/s"/>
+         <field field_ref="w850" name="W850"       long_name="Vertical velocity at 850 hPa"     unit="m/s"/>
+         <field field_ref="t850" name="T850"       long_name="Temperature at 850 hPa"   unit="K"/>
+         <field field_ref="omega850" name="OMEGA850"   long_name="Vertical pressure velocity at 850 hPa"     unit="Pa/s"/>
+         <field field_ref="u500" name="U500"       long_name="Zonal wind at 500 hPa"      unit="m/s"/>
+         <field field_ref="v500" name="V500"       long_name="Meridional wind at 850 hPa"   unit="m/s"/>
+         <field field_ref="w850" name="W500"       long_name="Vertical velocity at 500 hPa"     unit="m/s"/>
+         <field field_ref="t500" name="T500"       long_name="Temperature at 850 hPa"   unit="K"/>
+         <field field_ref="omega500" name="OMEGA500"   long_name="Vertical pressure velocity at 500 hPa"     unit="Pa/s"/>
+         <field field_ref="SST" name="SST"       long_name="Sea surface temperature"   unit="K"/>
+        
+       </field_group>
+
+
+<!--       <field field_ref="ulon_850_500" />  -->
+       
+     </file>
+     
+
+
+     <file_group id="read_files" enabled="false" >
+
+        <file id="relief" name="Relief" type="one_file" mode="read" >
+          <field id="relief_reg" name="RELIEF" domain_ref="domain_relief" operation="instant" />
+        </file>
+
+        <file id="ECDYN"  name="ECDYN4" type="one_file" mode="read" >
+           <field_group domain_ref="domain_ecdyn" operation="instant">
+              <field id="ps_reg"   name="SP"      />
+              <field id="z_reg"    name="Z"       />
+              <field id="ts_reg"   name="ST"      />
+              <field_group axis_ref="lev_ecdyn"   >
+                <field id="u_reg"    name="U"     />
+                <field id="v_reg"    name="V"     />
+                <field id="temp_reg" name="TEMP"  />
+                <field id="q_reg"    name="R"     />
+              </field_group>
+           </field_group>
+        </file>
+      </file_group> 
+
+   </file_definition>
+    
+    
+   <axis_definition>
+     <axis id="lev" positive="down" standard_name="atmopshere_hybrid_sigma_pressure_coordinate" long_name="hybrid level at midpoints" />
+     <axis id="levp1" name="ilev"  unit="level" positive="down" standard_name="atmopshere_hybride_sigma_pressure_coordinate" long_name="hybrid level at interface" />
+     <axis id="lev_pressure" positive="down"  n_glo="2" unit="Pa" value="(0,1)[85000 50000]" >
+       <interpolate_axis order="1" coordinate="p" />
+     </axis>
+      
+     <axis id="lev_ecdyn" unit="level" positive="down" />
+   </axis_definition>
+    
+
+   <domain_definition>
+     
+     <domain_group id="i"> 
+       <domain id="from_relief" >
+         <interpolate_domain/>
+       </domain>
+
+       <domain id="from_ecdyn" >
+         <interpolate_domain/>
+       </domain>
+
+       <domain id="i"/>
+     
+     </domain_group> 
+     
+     
+     <domain id="v" />
+
+     <domain id="domain_relief" type="rectilinear" >
+       <generate_rectilinear_domain />
+     </domain>
+
+     <domain id="domain_ecdyn" type="rectilinear" >
+       <generate_rectilinear_domain />
+     </domain>
+     
+     <domain id="regular" type="rectilinear" ni_glo="180" nj_glo="90" >
+       <generate_rectilinear_domain />
+       <interpolate_domain order="1"/>
+     </domain> 
+     
+   </domain_definition>    
+
+
+   <grid_definition>    
+
+     <grid id="scalar">
+     </grid>
+
+     <grid id="grid_relief">
+       <domain domain_ref="domain_relief"/>
+     </grid>
+
+     <grid id="from_relief">
+       <domain domain_ref="from_relief"/>
+     </grid>
+
+     <grid id="grid2d_ecdyn">
+       <domain domain_ref="domain_ecdyn"/>
+     </grid>
+
+     <grid id="from_ecdyn2d">
+       <domain domain_ref="from_ecdyn"/>
+     </grid>
+
+     <grid id="grid3d_ecdyn">
+       <domain domain_ref="domain_ecdyn"/>
+       <axis axis_ref="lev_ecdyn"/>
+     </grid>
+
+     <grid id="from_ecdyn3d">
+       <domain domain_ref="from_ecdyn"/>
+       <axis axis_ref="lev_ecdyn"/>
+     </grid>
+
+   </grid_definition>   
+    
+  
+ </context>
Index: codes/icosagcm/trunk/param_sets/dcmip2016/baroclinic_wave/iodef.xml
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2016/baroclinic_wave/iodef.xml	(revision 400)
+++ codes/icosagcm/trunk/param_sets/dcmip2016/baroclinic_wave/iodef.xml	(revision 400)
@@ -0,0 +1,21 @@
+<?xml version="1.0"?>
+<simulation> 
+	
+	<context  id="xios">
+		<variable_definition>
+                <variable id="print_file" type="bool"> true </variable> 
+                <variable id="min_buffer_size" type="double">1000000</variable> 
+       		<variable_group id="buffer">
+         	</variable_group>
+
+        	<variable_group id="parameters" >
+        		<variable id="using_server" type="bool">true</variable>
+        		<variable id="info_level" type="int">100</variable>
+        	</variable_group>
+		</variable_definition>
+	</context>
+	
+
+        <context id="icosagcm" src="./icosa.xml" /> 
+
+</simulation>